package  
{
  import flash.media.Sound;
  import flash.utils.Dictionary;
  public class xSoundMan 
  {
    
    //todo -- ambient sound (seperate from soundman and musman)

    
    //listener position and normal
    public var cx:Number = 0;    public var cy:Number = 0;    public var cz:Number = 0; 
    public var nx:Number = 0;    public var ny:Number = 0;    public var nz:Number = 0;

    public var bMute:Boolean = false;
    public var dictSnd:Dictionary = new Dictionary();    

    public var vecSound:Vector.<xSound> = new Vector.<xSound>(16, false);
    public var it:int = 0;
    
    public function setPos(ax:Number, ay:Number, az:Number):void
    { cx = ax; cy = ay; cz = az; }

    public function setNorm(ax:Number, ay:Number, az:Number):void
    { nx = ax; ny = ay; nz = az; }
    
    public function getFree():xSound
    {
      var a:xSound;
      a = vecSound[it]; if (a == null) { a = new xSound(); }
      a.clear();
      it += 1; if (it >= vecSound.length) { it = 0; }
      return a;
    }//getfree
    
    public function clear():void
    {
      var i:int; var num:int; var a:xSound;
      num = vecSound.length; it = 0;
      for (i = 0; i < num; i++)
      {
        a = vecSound[i];
        if (a == null) { continue; }
        a.clear();
      }//nexti
    }//clear  
    
    public function addSound(wname:String, embed:Class):void
    {
      dictSnd[wname] = (new embed) as Sound;
    }//addsound
    
    public function getSound(wname:String):Sound
    {
      var a:Sound;
      a = dictSnd[wname];
      if (a == null) { trace("xSoundMan  sound not found [" + wname + "]"); }
      return a;
    }//getsound 
    
    public function playSound(wname:String,  vm:Number = 1.0, pan:Number = 0.0):void
    { 
      var a:xSound;     var s:Sound;
      if (bMute) { return; }

        s = dictSnd[wname];        if (s == null) { trace("error: sound not found [" + wname + "]"); } 
       
       a = getFree();
       a.snd = s;       a.vol = vm;       a.pan = pan;
       a.play();
       
    }//playsound
    
    public function playSound3(wname:String, sx:Number, sy:Number, sz:Number, vm:Number = 1.0, maxdist:Number=320):void
    { 
      var a:xSound;    
      if (bMute) { return; }
      
     // a = getFree();
      var vol:Number;			var pan:Number;			
      var dx:Number;			var dy:Number;		var dz:Number;
			var dist:Number;
      
			dx = cx - sx;			dy = cy - sy;  dz = cz - sz;
			if (Math.abs(dx) > maxdist) { return; }
			if (Math.abs(dy) > maxdist) { return; } 
		  if (Math.abs(dz) > maxdist) { return; }
      
      dist = Math.sqrt(dx * dx + dy * dy + dz * dz)
			vol = 1 - (dist / maxdist);
      pan = (( (sx - cx) * nx) + ( (sy - cy) * ny) + ( (sz - cz) * nz) ) * 0.0075; // 0.01;
			
      trace(" dist ", dist.toFixed(2), "p: " , int(sx),int(sy),int(sz), "list: "  , int(cx), int(cy), int(cz));
      
			if (pan > 0.9) { pan = 0.9; }	else if (pan < -0.9) { pan = -0.9; }     
      if (vol <= 0.001) { return; }
      
        var s:Sound;
        s = dictSnd[wname];
        if (s == null) { trace("error: sound not found ["+wname+"]"); }
      
      a = getFree();
      
      // a = new xSound();
       a.snd = s
       a.vol = vol * vm;
       a.pan = pan;
       a.play();
        
    }//playsound
    

    
  }//classend

}
import flash.media.Sound;
import flash.media.SoundChannel;
import flash.media.SoundTransform;

internal class xSound
{
  public var chan:SoundChannel = null; 
  public var snd:Sound = null;
  public var vol:Number = 1.0;
  public var pan:Number = 0.0;

  public function play():void
  {
    var a:SoundTransform;
     a = new SoundTransform();
     a.volume = vol;
     a.pan = pan;   
     if (snd == null) { return; }
    chan = snd.play(0, 1, a);
  }//play
  
  
  public function clear():void
  { 
    if (chan == null) { return; }
    chan.stop();
    chan = null;
  }//clear
  
}//xsound


